# Summary

<!-- 本文档用于生成 Erg Book 不要添加徽章等 -->

- [基本](./00_basic.md)
- [字面量](./01_literal.md)
- [变量和常量](02_name.md)
- [声明](./03_declaration.md)
- [函数](./04_function.md)
- [内置函数](./05_builtin_funcs.md)
- [运算符](./06_operator.md)
- [副作用](./07_side_effect.md)
- [程序](./08_procedure.md)
- [内置程序](./09_builtin_procs.md)
- [数组](./10_array.md)
- [元组](./11_tuple.md)
- [字典](./12_dict.md)
- [记录(Record)](./13_record.md)
- [Set](./14_set.md)
- [类型](./15_type.md)
  - [类型系统](./type/01_type_system.md)
  - [基础](./type/02_basic.md)
  - [Trait](./type/03_trait.md)
  - [类](./type/04_class.md)
  - [继承](./type/05_inheritance.md)
  - [NST 与 SST](./type/06_nst_vs_sst.md)
  - [补丁](./type/07_patch.md)
  - [值类型](./type/08_value.md)
  - [属性类型](./type/09_attributive.md)
  - [区间类型](./type/10_interval.md)
  - [枚举类型](./type/11_enum.md)
  - [强化类型](./type/12_refinement.md)
  - [代数类型](./type/13_algebraic.md)
  - [依赖类型](./type/14_dependent.md)
  - [量化类型](./type/15_quantified.md)
  - [子类型](./type/16_subtyping.md)
  - [类型转换](./type/17_type_casting.md)
  - [可变类型](./type/18_mut.md)
  - [高级类型](./type/advanced.md)
    - [默认参数](./type/advanced/default_param.md)
    - [类型擦除](./type/advanced/erasure.md)
    - [存在类型](./type/advanced/existential.md)
    - [GADTs](./type/advanced/GADTs.md)
    - [关键字参数](./type/advanced/keyword_param.md)
    - [Kind(类型的类型)](./type/advanced/kind.md)
    - [标记Trait](./type/advanced/marker_trait.md)
    - [可变结构](./type/advanced/mut_struct.md)
    - [幻象类型](./type/advanced/phantom.md)
    - [投影类型](./type/advanced/projection.md)
    - [量化依赖类型](./type/advanced/quantified_dependent.md)
    - [共享引用](./type/advanced/shared.md)
- [迭代器](./16_iterator.md)
- [可变性](./17_mutability.md)
- [所有权](./18_ownership.md)
- [可见性](./19_visibility.md)
- [命名规则](20_naming_rule.md)
- [Lambda](./21_lambda.md)
- [子程序](./22_subroutine.md)
- [闭包](./23_closure.md)
- [模块](./24_module.md)
- [对象系统](./25_object_system.md)
- [模式匹配](./26_pattern_matching.md)
- [推导式](./27_comprehension.md)
- [扩展语法](./28_spread_syntax.md)
- [装饰器](./29_decorator.md)
- [错误处理](./30_error_handling.md)
- [管道运算符](./31_pipeline.md)
- [与 Python 集成](./32_integration_with_Python.md)
- [包系统](./33_package_system.md)
- [生成器](./34_generator.md)
- [快速游览](./quick_tour.md)
- [索引](./indexes.md)
